"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$api = void 0;
var tslib_1 = require("tslib");
var HttpService_1 = require("../../src/services/HttpService");
var sleep_promise_1 = tslib_1.__importDefault(require("sleep-promise"));
var ApiService = /** @class */ (function (_super) {
    tslib_1.__extends(ApiService, _super);
    function ApiService(config) {
        var _this = _super.call(this, config) || this;
        _this.mock = jest.fn(_this.httpHandler.request);
        _this.httpHandler.request = _this.mock;
        return _this;
    }
    ApiService.prototype.mockResolveValue = function (data, duration) {
        var _this = this;
        if (duration === void 0) { duration = 0; }
        this.mock.mockImplementationOnce(function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(duration > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, sleep_promise_1.default(duration)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, {
                            data: data,
                        }];
                }
            });
        }); });
    };
    ApiService.prototype.mockRejectValue = function (data) {
        this.mock.mockRejectedValue({
            data: data,
        });
    };
    return ApiService;
}(HttpService_1.HttpService));
exports.$api = new ApiService({
    baseUrl: '',
    headers: function () {
        return {};
    },
    isSuccess: function () {
        return true;
    },
    onRespondError: function (response, transform) {
        transform.message = response.data.error;
    },
    onShowSuccess: function () { },
    onShowError: function () { },
    timeoutMessage: function () {
        return 'Timeout!';
    },
});
