"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.effectModel = exports.EffectModel = void 0;
var tslib_1 = require("tslib");
var Model_1 = require("../../src/models/Model");
var BasicModel_1 = require("./BasicModel");
var RequestModel_1 = require("./RequestModel");
var EffectModel = /** @class */ (function (_super) {
    tslib_1.__extends(EffectModel, _super);
    function EffectModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.reset = _this.action(function (state) {
            state.counter = 0;
        });
        return _this;
    }
    EffectModel.prototype.effects = function () {
        return [
            BasicModel_1.basicModel.effectOtherModel.onSuccess(function (state) {
                state.counter += 1;
            }),
            BasicModel_1.basicModel.effectWithPayload.onSuccess(function (state, action) {
                state.counter = action.payload.counter;
            }),
            RequestModel_1.requestModel.getNpmInfo.onPrepare(function (state) {
                state.counter += 5;
            }),
            RequestModel_1.requestModel.getNpmInfo.onSuccess(function (state) {
                state.counter += 7;
            }),
            RequestModel_1.requestModel.getNpmInfo.onFail(function (state) {
                state.counter += 10;
            }),
        ];
    };
    EffectModel.prototype.initReducer = function () {
        return {
            counter: 0,
            foo: 'foo',
            bar: 'bar',
        };
    };
    return EffectModel;
}(Model_1.Model));
exports.EffectModel = EffectModel;
exports.effectModel = new EffectModel();
