"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var sleep_promise_1 = tslib_1.__importDefault(require("sleep-promise"));
var PersistAutoModel_1 = require("./PersistAutoModel");
var createReduxStore_1 = require("../../src/stores/createReduxStore");
var core_1 = require("../../src/core");
test('Initial data will be used if persist data is missing', function (done) {
    localStorage.setItem('ReduxModel:Persist:test-persist', '{"model":"{\\"counter\\":5}","__persist":{"version":1}}');
    createReduxStore_1.createReduxStore({
        persist: {
            version: 1,
            key: 'test-persist',
            storage: 'local',
            allowlist: {
                model: 'PersistAutoModel.a',
                model2: 'PersistAutoModel.b',
            },
        },
    });
    core_1.storeHelper.persist.listen(function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var model, model2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    model = new PersistAutoModel_1.PersistAutoModel('a');
                    model2 = new PersistAutoModel_1.PersistAutoModel('b');
                    expect(model.data.counter).toBe(5);
                    model.increase();
                    expect(model.data.counter).toBe(6);
                    expect(model2.data.counter).toBe(0);
                    model2.increase();
                    expect(model2.data.counter).toBe(1);
                    return [4 /*yield*/, sleep_promise_1.default(10)];
                case 1:
                    _a.sent();
                    expect(localStorage.getItem('ReduxModel:Persist:test-persist')).toBe('{"model":"{\\"counter\\":6}","model2":"{\\"counter\\":1}","__persist":{"version":1}}');
                    model.increase();
                    expect(model.data.counter).toBe(7);
                    model2.increase();
                    expect(model2.data.counter).toBe(2);
                    return [4 /*yield*/, sleep_promise_1.default(10)];
                case 2:
                    _a.sent();
                    expect(localStorage.getItem('ReduxModel:Persist:test-persist')).toBe('{"model":"{\\"counter\\":7}","model2":"{\\"counter\\":2}","__persist":{"version":1}}');
                    done();
                    return [2 /*return*/];
            }
        });
    }); });
});
