import { Model } from '../../src/models/Model';
interface Response {
    id: number;
    name: string;
    age?: number;
}
declare type Data = Response & {
    records: Partial<{
        [key: string]: {
            id: number;
            name: string;
            age?: number;
        };
    }>;
};
export declare class RequestModel extends Model<Data> {
    getProfile: (() => import("../../src").FetchHandle<Response, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, () => import("../../src/core").HttpServiceBuilderWithMeta<Data, Response, unknown, import("axios").AxiosRequestConfig, true>, Response, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    withPostProfile: (() => import("../../src").FetchHandle<unknown, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, () => import("../../src/core").HttpServiceBuilderWithMeta<Data, unknown, unknown, import("axios").AxiosRequestConfig, true>, unknown, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    withPutProfile: (() => import("../../src").FetchHandle<unknown, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, () => import("../../src/core").HttpServiceBuilderWithMeta<Data, unknown, unknown, import("axios").AxiosRequestConfig, true>, unknown, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    withDeleteProfile: (() => import("../../src").FetchHandle<unknown, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, () => import("../../src/core").HttpServiceBuilderWithMeta<Data, unknown, unknown, import("axios").AxiosRequestConfig, true>, unknown, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    getNpmInfo: ((packageName: string) => import("../../src").FetchHandle<unknown, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, (packageName: string) => import("../../src/core").HttpServiceBuilderWithMeta<Data, unknown, unknown, import("axios").AxiosRequestConfig, true>, unknown, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    getNpmInfoWithTimeout: ((packageName: string) => import("../../src").FetchHandle<unknown, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, (packageName: string) => import("../../src/core").HttpServiceBuilderWithMeta<Data, unknown, unknown, import("axios").AxiosRequestConfig, true>, unknown, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    enableThrottleProfile: (() => import("../../src").FetchHandle<{
        id: number;
    }, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, () => import("../../src/core").HttpServiceBuilderWithMeta<Data, {
        id: number;
    }, unknown, import("axios").AxiosRequestConfig, true>, {
        id: number;
    }, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    disableCacheProfile: (() => import("../../src").FetchHandle<{
        id: number;
    }, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, () => import("../../src/core").HttpServiceBuilderWithMeta<Data, {
        id: number;
    }, unknown, import("axios").AxiosRequestConfig, true>, {
        id: number;
    }, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    configurableThrottle: ((useCache: boolean) => import("../../src").FetchHandle<{
        id: number;
    }, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, (useCache: boolean) => import("../../src/core").HttpServiceBuilderWithMeta<Data, {
        id: number;
    }, unknown, import("axios").AxiosRequestConfig, true>, {
        id: number;
    }, unknown, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    getProfileById: ((id: number) => import("../../src").FetchHandle<Response, unknown>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, (id: number) => import("../../src/core").HttpServiceBuilderWithMetas<Data, Response, unknown, import("axios").AxiosRequestConfig, number>, Response, unknown, number>, "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "metas" | "loadings" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMetas" | "useLoadings">;
    payloadRequest: ((who: string) => import("../../src").FetchHandle<Response, {
        who: string;
    }>) & Pick<import("../../src/actions/RequestAction").RequestAction<Data, (who: string) => import("../../src/core").HttpServiceBuilderWithMeta<Data, Response, {
        who: string;
    }, import("axios").AxiosRequestConfig, true>, Response, {
        who: string;
    }, true>, "loading" | "meta" | "model" | "__isAction__" | "getSuccessType" | "getActionName" | "setName" | "uniqueId" | "onPrepare" | "onSuccess" | "onFail" | "clearThrottle" | "getPrepareType" | "getFailType" | "useMeta" | "useLoading">;
    orphanGetRequest(): Promise<Response>;
    protected initReducer(): Data;
}
export declare const requestModel: RequestModel;
export {};
