"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestModel = exports.RequestModel = void 0;
var tslib_1 = require("tslib");
var ApiService_1 = require("./ApiService");
var Model_1 = require("../../src/models/Model");
var RequestModel = /** @class */ (function (_super) {
    tslib_1.__extends(RequestModel, _super);
    function RequestModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getProfile = ApiService_1.$api.action(function () {
            return _this
                .get('/profile.json')
                .onPrepare(function (state) {
                Object.assign(state, {
                    id: 666,
                    name: 'iPhone',
                });
            })
                .onSuccess(function (state, action) {
                Object.assign(state, action.response);
            })
                .onFail(function (state) {
                Object.assign(state, {
                    id: 1000,
                    name: 'nokia',
                });
            });
        });
        _this.withPostProfile = ApiService_1.$api.action(function () {
            return _this.post('/profile/create');
        });
        _this.withPutProfile = ApiService_1.$api.action(function () {
            return _this.put('/profile/create');
        });
        _this.withDeleteProfile = ApiService_1.$api.action(function () {
            return _this.delete('/profile/create');
        });
        _this.getNpmInfo = ApiService_1.$api.action(function (packageName) {
            return _this.get('https://registry.npmjs.org/' + packageName);
        });
        _this.getNpmInfoWithTimeout = ApiService_1.$api.action(function (packageName) {
            return _this
                .get('https://registry.npmjs.org/' + packageName)
                .requestOptions({
                timeout: 2,
            });
        });
        _this.enableThrottleProfile = ApiService_1.$api.action(function () {
            return _this
                .get('/profile/manage')
                .throttle(3000);
        });
        _this.disableCacheProfile = ApiService_1.$api.action(function () {
            return _this
                .get('/profile/manage')
                .throttle({
                duration: 3000,
                enable: false,
            });
        });
        _this.configurableThrottle = ApiService_1.$api.action(function (useCache) {
            return _this
                .get('/profile/manage')
                .throttle({
                duration: 3000,
                enable: useCache,
            });
        });
        _this.getProfileById = ApiService_1.$api.action(function (id) {
            return _this
                .get('/profile.json')
                .metas(id)
                .onSuccess(function (state, action) {
                state.records[id] = action.response;
            });
        });
        _this.payloadRequest = ApiService_1.$api.action(function (who) {
            return _this
                .get('/profile.json')
                .payload({
                who: who,
            });
        });
        return _this;
    }
    RequestModel.prototype.orphanGetRequest = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var profile;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, ApiService_1.$api.getAsync({
                            uri: '/profile.json',
                        })];
                    case 1:
                        profile = _a.sent();
                        return [2 /*return*/, profile.response];
                }
            });
        });
    };
    RequestModel.prototype.initReducer = function () {
        return {
            id: 1,
            name: 'init-name',
            records: {},
        };
    };
    return RequestModel;
}(Model_1.Model));
exports.RequestModel = RequestModel;
exports.requestModel = new RequestModel('default');
